//This function initializes server_fd variable

#include "webkit_client.h"

__attribute__((visibility("hidden")))extern trace g_t1;
using namespace std;
int webkit_client::server_fd = -1;
PF* webkit_client::func_array;

//Close the socket, close more gracefully by sending cancel event to g_recv_thread_id
void webkit_client::deinitComm(){
    int err;
    g_t1.logInfo("WEBKIT: Entered webkit_client\n");


    if(server_fd != -1){
        err = close(server_fd);
        if(err == -1){
            printf("Could not close webkit_client::server_fd, error: %s\n",strerror(errno));
            g_t1.logInfo("WEBKIT: Could not close webkit_client::server_fd, error: %s\n", strerror(errno));
        }
        server_fd = -1;
    }
    else{
        g_t1.logInfo("WEBKIT: webkit_client:: deinitComm, webkit_client::server_fd is already closed\n");
        printf("webkit_client::server_fd is already closed\n");
    }

}


void webkit_client::initComm(PF* arr, char* sock){

    pthread_attr_t tattr;
    g_t1.logInfo("WEBKIT: Entered webkit_client::initCom()\n");
    //First inititalize func_array
    func_array = arr;
    pthread_t recv_thread_id; //Thread that runs recvMessage
   

    pthread_attr_init(&tattr);
    pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
    //Create a thtread. This thread will initialize server_fd and start receiveing messages in an infinite loop
    pthread_create(&recv_thread_id, &tattr, sinitComm, (void*)sock);
    pthread_attr_destroy(&tattr);

}

//Connect to server_fd and start receiveing messages.
void* webkit_client::sinitComm(void* args){


    char* socket_path = (char*)args;
    struct sockaddr_un addr;


    if ( (server_fd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
        perror("socket error");
        g_t1.logInfo("WEBKIT: webkit_client::sinitCom, Could not create socket\n");
        pthread_exit(NULL);
    }

    memset(&addr, 0, sizeof(addr));
    addr.sun_family = AF_UNIX;
    strncpy(addr.sun_path, socket_path, sizeof(addr.sun_path)-1);

    if (connect(server_fd, (struct sockaddr*)&addr, sizeof(addr)) == -1) {
        g_t1.logInfo("WEBKIT: webkit_client::sinitCom, Connection error with webkit_server");
        perror("connect error");
        pthread_exit(NULL);
    }

    /* Now as the connection is established, we can move ahead and send the PID of the extension process
        This is the best place to do it */
    std::vector<int> intList;
    intList.push_back(getpid());
    std::vector<std::string> stringList;
    webkit_message *s = webkit_util::wrapMessage(enum_pidOfExt, intList, stringList);
    webkit_client::sendMessage(s);
    free(s);

    free(socket_path);

    //recvMessage indefinitely
    webkit_client::recvMessage();


    return (void*)0;
}



void webkit_client::processMessage(webkit_message* &s){

    int args1[s->total_int_args];
    //Here adding extra '/0' string in the end so that ctxs_cb_wrapper can calculate the total length of the array.
    std::string args2[s->total_string_args + 1]; 

    int cur = 0;
    char* buf = (char*)malloc(BUFSIZE);

    for(int i=0; i<s->total_int_args; i++){

        args1[i] = webkit_util::parseNextInt(cur, s->serialized_arg, buf);

    }

    for(int i=0;i<s->total_string_args;i++){

        args2[i] = webkit_util::parseNextString(cur, s->serialized_arg, buf);

    }
    args2[s->total_string_args] = "\0";


    func_array[s->func_name](args1, args2);

    free(buf);

}

//infinite loop running function which waits for any data on the server_fd
void webkit_client::recvMessage(){

    webkit_message *s;
    int wrv;
    char* buf1 = (char*)malloc(BUFSIZE);
    if(buf1 == NULL){
        perror("webkit_client::recvMessage could not malloc, failing \n");
        g_t1.logInfo("WEBKIT: webkit_client::recvMessage, could not malloc %d, too less memory?", BUFSIZE);
        pthread_exit(NULL);
    }
    int total_len_of_string;

    if(server_fd == -1){
        perror("webkit_client::recvMessage Error in server_fd\n");
        g_t1.logInfo("WEBKIT: webkit_client::recvMessage, server_fd == -1, haven't connected with server yet");
        pthread_exit(NULL);
    }

    memset(buf1, 0, BUFSIZE);

    while(1){



        while(1){
            wrv = read(server_fd, buf1, 4*sizeof(int));
            if(wrv==0){
             continue;
            }
            else{
                break;
            }
                
        }
        g_t1.logInfo("Value of server_fd %d", server_fd);

        if(wrv != 4*sizeof(int)){

            printf("webkit_client::recvMessage Error in reading first four ints in recvMessage in webkit_client %s\n", strerror(errno));
            g_t1.logInfo("WEBKIT: webkit_client::recvMessage Error in reading first four ints in recvMessage in webkit_client %s\n", strerror(errno));
            pthread_exit(NULL);

        }

        total_len_of_string = *(int *)(buf1 + 3*sizeof(int));

        s = (webkit_message*)malloc(sizeof(webkit_message) + total_len_of_string);

        s->func_name = *(func_enum*)buf1;
        s->total_int_args = *((int *)((char*)buf1 + 1*sizeof(int)));
        s->total_string_args = *((int *)((char*)buf1 + 2*sizeof(int)));
        s->total_len_of_string = *(int *)((char*)buf1 + 3*sizeof(int));

        if(s->total_len_of_string > BUFSIZE){
            g_t1.logInfo("webkit_client::recvMessage  BUFSIZE VALUE: %d", BUFSIZE);
            g_t1.logInfo("WEBKIT: webkit_client::recvMessage, s->total_len_of_string is more than the capacity BUFSIZE VALUE, exiting thread \n");
            pthread_exit(NULL);
        }

        memset(buf1, 0, BUFSIZE);
        int to_be_read = s->total_len_of_string;

        if(s->total_len_of_string != 0){

            while(to_be_read != 0){

                wrv = read(server_fd, buf1, to_be_read);
                if(wrv==0){
                    continue;
                }
                else{
                    if(wrv < 0){
                        printf("webkit_client::recvMessage Error in reading in webkit_client %s \n", strerror(errno));
                        g_t1.logInfo("WEBKIT: webkit_client::recvMessage, Error in reading in webkit_client, exiting thread %s\n", strerror(errno));
                        pthread_exit(NULL);

                    }
                    else{
                        memcpy((s->serialized_arg) + (s->total_len_of_string - to_be_read), buf1, wrv);
                        to_be_read = to_be_read - wrv;
                        assert(to_be_read >=0);
                        memset(buf1, 0, BUFSIZE);
                    }

                }
                    
            }
        }
        processMessage(s);
        free(s);
    }

    free(buf1);
}



void webkit_client::sendMessage(webkit_message* &s){

    static char *buf = (char*)malloc(BUFSIZE);
    int wrv;
    int size_struct = sizeof(webkit_message) + s->total_len_of_string;


    memcpy(buf, s, size_struct);
    
    if(server_fd == -1){
        perror("webkit_client::sendMessage server_fd not initialized yet\n");
        g_t1.logInfo("WEBKIT: sendmMessage server_fd not initialized yet, returning\n");
        return;
    }

    wrv = write(server_fd, buf, size_struct);
    if(wrv != size_struct){
        if(wrv > 0){
            g_t1.logInfo("WEBKIT: Partial write, exiting, value of wrv is %d\n", wrv);
            exit(-1);
        }
        else{
            g_t1.logInfo("WEBKIT: Could not write, error: %s, exiting\n", strerror(errno));
            perror("Error writing into the socket\n");
            exit(-1);
        }
    }
}

