
#include "UIDialogLibWebKit_ext.h"
#include "LinuxCommonUtilsSDK.cpp"

using namespace std;


gulong ms_woc_signal = 0; 
trace g_t1;
static void getStringFromJavascriptRef(const JSContextRef ctx, const JSValueRef arg, std::string& str)
{

    JSStringRef jstring = JSValueToStringCopy(ctx, arg, NULL);

    if (jstring == NULL)
    {
        g_t1.logInfo("getStringFromJavascript Ref failed \n");
        return;
    }

    size_t len = JSStringGetMaximumUTF8CStringSize(jstring);

    char arg_buf[len];
    JSStringGetUTF8CString(jstring, arg_buf, len);
    str = arg_buf;
    JSStringRelease(jstring);
    // std::cout << std::string( 15, ' ' ) << "SsJS_proxy::getStringFromJavascriptRef Finished\n";
}

namespace UIDialogLibWebKit_ext
{

/* Callback on the "window.external.citrixExitWebview(samlResponse)"
    javascript function in the webview. */
/* static */ JSValueRef onCitrixExitWebview(JSContextRef ctx,
                                            JSObjectRef unused_function,
                                            JSObjectRef unused_thisObject,
                                            size_t argumentCount,
                                            const JSValueRef arguments[],
                                            JSValueRef *unused_exception)
    {
        if (argumentCount != 1)
        {
            g_t1.logInfo("UIDIALOGLIB: onCitrixExitWebview arg count not equal to 1, exiting\n");
            return JSValueMakeUndefined(ctx);
        }

        std::string response; 

        /* This call dynamically allocates enough memory to store the token.
            It is the caller's resposibility to free the memory after use. */
        //Get the
        getStringFromJavascriptRef(ctx, arguments[0], response);

        std::vector<int> intList;
        std::vector<std::string> stringList;
        stringList.push_back(response);
        webkit_message *s = webkit_util::wrapMessage(enum_onCitrixExitWebview, intList, stringList);

        webkit_client::sendMessage(s);
        free(s);
        g_t1.logInfo("Finished sending webkit_message in onCitrixExitWebview(token)\n");

        return JSValueMakeUndefined(ctx);
    }


    PF* getFunctionArray(){

        PF* func_array = new PF[TOTAL_FUNCTIONS + 1];
        return func_array;

    }

} // namespace UIDialogLibWebKit_ext

/* JavaScript functions can only be called from the GTK thread. */
/* static */ void loadJavascriptApi(JSContextRef jsContext,
                                    JSObjectRef parentObject)
{
    /* Set the callback for the javascript function "window.external.citrixExitWebview",
       called when the authentication process is completed. */
    JSStaticFunction js_static_functions[] = {
        {"citrixExitWebview", UIDialogLibWebKit_ext::onCitrixExitWebview, kJSPropertyAttributeReadOnly},
        {NULL, NULL, 0}};

    JSClassDefinition js_class_definition = {
        0,                     /* version */
        kJSClassAttributeNone, /* attributes */
        "JSAPI",               /* className */
        NULL,                  /* parentClass */
        NULL,                  /* staticValues */
        js_static_functions,   /* staticFunctions */
        NULL,                  /* initialize */
        NULL,                  /* finalize */
        NULL,                  /* hasProperty */
        NULL,                  /* getProperty */
        NULL,                  /* setProperty */
        NULL,                  /* deleteProperty */
        NULL,                  /* getPropertyNames */
        NULL,                  /* callAsFunction */
        NULL,                  /* callAsConstructor */
        NULL,                  /* hasInstance */
        NULL                   /* convertToType */
    };

    /* Create the class from the structures above. */
    JSClassRef js_class = JSClassCreate(&js_class_definition);

    /* Create an instance of the class we just created. */
    JSObjectRef js_object = JSObjectMake(jsContext, js_class, NULL);

    /* Add the callback instances to "window.external". */
    JSStringRef prop_str = JSStringCreateWithUTF8CString("external");
    JSObjectSetProperty(jsContext,
                        parentObject,
                        prop_str,
                        js_object,
                        kJSPropertyAttributeNone,
                        NULL);
    JSStringRelease(prop_str);
}

/* Callback to setup Javascript. */
/*static*/ void onWindowObjectCleared(WebKitScriptWorld *world,
                                      WebKitWebPage *web_page,
                                      WebKitFrame *frame,
                                      gpointer data)
{
    /* According to the WebKitGTK+ documentation this is the best place to
       add to the window object from the JavaScriptCore. */

    // g_signal_handler_disconnect(world, ms_woc_signal);
    // ms_woc_signal = 0;

    g_t1.logInfo("UIDIALOGLIB: Inside onWindowObjectCleared callback\n");
    JSGlobalContextRef jsContext = webkit_frame_get_javascript_context_for_script_world(frame, world);
    JSObjectRef windowObject = (JSObjectRef)JSContextGetGlobalObject(jsContext);
    loadJavascriptApi((JSContextRef)jsContext, (JSObjectRef)windowObject);

}

/* Converts a Javascript string into a null-terminated UTF8 string.
   It is the caller's responsibility to free the newly created string. */
/* static */ void getStringFromJavascriptRef(const JSContextRef ctx,
                                             const JSValueRef arg,
                                             char **buf)
{
    if (buf == NULL)
    {
        return;
    }

    /* Clear the buffer if necessary. */
    free(*buf);
    *buf = NULL;

    JSStringRef jstring = JSValueToStringCopy(ctx, arg, NULL);

    size_t len = JSStringGetMaximumUTF8CStringSize(jstring);
    *buf = (char *)malloc(len * sizeof(char));
    JSStringGetUTF8CString(jstring, *buf, len);

    JSStringRelease(jstring);
}


    

G_MODULE_EXPORT void webkit_web_extension_initialize_with_user_data(WebKitWebExtension *extension, GVariant *user_data)
{
    char* icaroot;
    std::string icaclient, sock_path;
    char* sock_path_ch;
    g_variant_get(user_data, "s", &icaroot);
    g_t1 = trace::init((char*)"uidialoglib", (char*)icaroot);
    g_t1.logInfo("UIDIALOGLIB: uidialog initialized in the extension process as well\n");

    if (extension == NULL)
    {
        g_t1.logInfo("extension is null, exiting\n");
        perror("Extension is null\n");
        exit(0);
    }

    ms_woc_signal = g_signal_connect(webkit_script_world_get_default(),
                                        "window-object-cleared",
                                        G_CALLBACK(onWindowObjectCleared),
                                        NULL);


    icaclient = LinuxCommonUtils::getHomeDir();
    icaclient = icaclient + std::string("/.ICAClient");
    if(!LinuxCommonUtils::ifFileExists(icaclient)){
        std::cerr << ".ICAClient not created, anomoly use case, exiting\n";
        exit(0);

    }

    sock_path = icaclient + std::string("/webkit_socket1");
    g_t1.logInfo("This is the sock_path %s \n", sock_path.c_str());

    sock_path_ch  = (char*)malloc(SOCK_PATH_LEN);
    strcpy(sock_path_ch, sock_path.c_str());


    webkit_client::initComm(UIDialogLibWebKit_ext::getFunctionArray(), sock_path_ch);
    
}